#ifndef _A3CSTORAGEBA_HXX_
#define _A3CSTORAGEBA_HXX_

#include <Main/Management/Attributes/BaseAttr.hxx>
#include "modules\a3cstoragedatabase\inc\repository.hxx"
#include "Modules\Cabin\include\Common\GadgetContainer.hxx"

class IlvMenuItem;
class IlvTreeGadget;
class IlvTreeGadgetItem;
class IlvStringList;
class IlvMatrix;

namespace Pace 
{
namespace A3CStorage
{



class A3CAdminToolDlg : public cabinlayout::PaceGadgetContainer
{
public:

	static A3CAdminToolDlg* Exemplar();
	~A3CAdminToolDlg();

	void Show();
	void DoRefreshVersions();
	void DoRuleRefreshVersions();

	// callbacks
	static void OnClose(IlvGraphic* , IlvAny );
	// user data
	static void OnUploadUserData(IlvGraphic* , IlvAny );
	// cabin item baseline
	static void OnRefreshVersions(IlvGraphic* , IlvAny );
	static void OnVersionSelect(IlvGraphic* , IlvAny );
	static void OnDefineBaseline(IlvGraphic* , IlvAny );
	static void OnCommitBaseline(IlvGraphic* , IlvAny );
	static void OnRollbackBaseline(IlvGraphic* , IlvAny );
	static void OnShowDiffOnly(IlvGraphic* , IlvAny );
	static void OnExpandItem(IlvGraphic* , IlvAny );
	static void OnShowItem(IlvGraphic* , IlvAny );

	// rule item baseline
	static void OnRuleRefreshVersions(IlvGraphic* , IlvAny );
	static void OnRuleVersionSelect(IlvGraphic* , IlvAny );
	static void OnRuleDefineBaseline(IlvGraphic* , IlvAny );
	static void OnRuleCommitBaseline(IlvGraphic* , IlvAny );
	static void OnRuleRollbackBaseline(IlvGraphic* , IlvAny );
	static void OnRuleShowDiffOnly(IlvGraphic* , IlvAny );
	static void OnRuleExpandItem(IlvGraphic* , IlvAny );
	static void OnRuleShowItem(IlvGraphic* , IlvAny );

	// PR Admin
	static void OnPREnterEdit(IlvGraphic* , IlvAny );
	static void OnPRUpload(IlvGraphic* , IlvAny );
	// organisation
	static void OnOrgSelect(IlvGraphic* , IlvAny );
	static void OnOrgAddSibling(IlvGraphic* , IlvAny );
	static void OnOrgAddChild(IlvGraphic* , IlvAny );
	static void OnOrgDeleteEntry(IlvGraphic* , IlvAny );
	static void OnOrgRename(IlvGraphic* , IlvAny );
	// CCG
	static void OnCcgSelect(IlvGraphic* , IlvAny );
	static void OnCcgNew(IlvGraphic* , IlvAny );
	static void OnCcgRename(IlvGraphic* , IlvAny );
	static void OnCcgDelete(IlvGraphic* , IlvAny );
	// Customer
	static void OnCustomerSelect(IlvGraphic* , IlvAny );
	static void OnCustomerNew(IlvGraphic* , IlvAny );
	static void OnCustomerChange(IlvGraphic* , IlvAny );
	static void OnCustomerRename(IlvGraphic* , IlvAny );
	static void OnCustomerDelete(IlvGraphic* , IlvAny );
	// Aircraft
	static void OnAcSelect(IlvGraphic* , IlvAny );
	static void OnAcNew(IlvGraphic* , IlvAny );
	static void OnAcDelete(IlvGraphic* , IlvAny );
	static void OnAcOpenSsp(IlvGraphic* , IlvAny );
	static void OnAcSelectSsp(IlvGraphic* , IlvAny );
	static void OnAcOpenCcg(IlvGraphic* , IlvAny );
	static void OnAcSelectCcg(IlvGraphic* , IlvAny );
	static void OnAcSelectTemplate(IlvGraphic* , IlvAny );
	



private:
    static const PaceString _strDlgName;
	static const PaceString _strIlvFilename;
	static A3CAdminToolDlg* _exemplar;
	A3CAdminToolDlg();

	static void InsertColumnHead(const char* caption_, int col_, IlvMatrix* pM_);
	// cabin item baseline
	void SetVersion();
	void BaselineUnderConstruction(bool commit_, const std::string& lockedBy_);
	void FillTree();
	void ExpandItem();
	void ShowItem();
	void ToggleShowDiff();
	// rule baseline
	void RuleSetVersion();
	void RuleBaselineUnderConstruction(bool commit_, const std::string& lockedBy_);
	void RuleFillTree();
	void FillRuleFolder(IlvTreeGadgetItem* pItm_, boost::shared_ptr<A3CStorage::CI::ClassInst> rf_);
	void RuleExpandItem();
	void RuleShowItem();
	void RuleToggleShowDiff();
	// PR Admin
	void PRAdjustToolbar();
	// organisation
	void OrgFillTree();
	void OrgSelect();
	void OrgAddSibling();
	void OrgAddChild();
	void OrgDeleteEntry();
	void OrgRename();
	// CCG
	void CcgFillList();
	void CcgSelect();
	void CcgNew();
	void CcgRename();
	void CcgDelete();
	// Customer
	void CustomerFillMtx();
	void CustomerSelect();
	void CustomerNew();
	void CustomerChange();
	void CustomerRename();
	void CustomerDelete();
	// Aircraft
	void AcFillMtx();
	void AcInsertRow(PR::Aircraft *ac_);
	void AcSelect();
	void AcNew();
	void AcDelete();
	void AcOpenSsp();
	void AcSelectSsp();
	void AcOpenCcg();
	void AcSelectCcg();
	void AcSelectTemplate();

	IlvButton* _pBtnUploadUser;
	
	IlvTreeGadget* _pCITree;
	IlvMenuItem* _pItmBLDefine;
	IlvMenuItem* _pItmBLCommit;
	IlvMenuItem* _pItmBLRollback;
	bool _BLShowDiff;

	IlvTreeGadget* _pRLTree;
	IlvMenuItem* _pItmRuleBLDefine;
	IlvMenuItem* _pItmRuleBLCommit;
	IlvMenuItem* _pItmRuleBLRollback;
	bool _RuleBLShowDiff;
	std::map<IlvTreeGadgetItem*, boost::shared_ptr<CI::ClassInst> > _treeitm;

	bool _editMode;
	IlvMenuItem* _pItmPREnterEditCust;
	IlvMenuItem* _pItmPRUploadCust;
	
	IlvMenuItem* _pItmPREnterEditOrg;
	IlvMenuItem* _pItmPRUploadOrg;
	
	IlvTreeGadget* _pOrgTree;
	IlvMenuItem* _pItmOrgAddSib;
	IlvMenuItem* _pItmOrgAddChi;
	IlvMenuItem* _pItmOrgDel;

	IlvStringList* _pCcgList;
	IlvMenuItem* _pItmCcgNew;
	IlvMenuItem* _pItmCcgDel;

	IlvMatrix* _pCustMtx;
	IlvMenuItem* _pItmCustNew;
	IlvMenuItem* _pItmCustDel;
	bool _custChanged;
	unsigned short _custRow;
	std::string _custName, _custICAO;

	IlvMatrix* _pAcMtx;
	IlvMenuItem* _pItmAcNew;
	IlvMenuItem* _pItmAcDel;

	
};

}
}

#endif
