//                                              ______
//                                                   `
// (c) 2004 by                              P A C E   /\ 
//                                                      
// Aerospace Engineering and Information Technology GmbH
//                                                      
// ---------------------------------------------------------------------------
// $Workfile: AutoCADExporter.hxx $
// ---------------------------------------------------------------------------
//                                                
// A3C class for 2D graphics export to AutoCAD.
// (Origin: Jul 2004 Christian R. Krug)
//
// $Author: Juergenf $
// $Date: 31.03.05 18:43 $
// $Revision: 2 $
// $Modtime: 22.11.04 17:49 $
//

#ifndef _cabinlayout_AutoCADExporter_HeaderFile
#define _cabinlayout_AutoCADExporter_HeaderFile

#include <Main\UserInterface\MainDial\SubViews\2d-Sketch\Export\AbstractExporter.hxx>

namespace cabinlayout {
	
	class AutoCADExporter : public Pace::PLKern::MainDial::AbstractExporter {
		
	public:
		
		AutoCADExporter();

		// This method is non-const intentionally to allow concrete exporter
		// classes modify their internal data.
		virtual	bool export (IlvView * pView_,
							 const PaceString & rstrFileName_,
							 const PaceString & rstrFileExtension_,
							 PaceDrawingPort const *  pDrawPort_,
							 const IlvTransformer * const = NULL);
		virtual	bool export (const char* strFileName_)
		{
			return export(NULL, strFileName_, PaceString(), NULL);
		}
		
	private:
	
		void _InitFormatList();
	};
}

#endif