//----------------------------------------------------------------------------
// configure.h
//----------------------------------------------------------------------------
//
// Creation: Carsten May
//
//----------------------------------------------------------------------------
//
// Provided datatypes: defines that should be forced at compilation time
//						add to cl comand line via /Fi Option
//
//----------------------------------------------------------------------------
#ifndef _CONFIGURE_H
#define _CONFIGURE_H

#define AS_LIB 1
#define AS_DLL 2

#define WHICH_WAY				AS_DLL

#define _PACE_USE_EXCEPTIONHANDLING_			WHICH_WAY
#define _PACE_USE_CDBC_							WHICH_WAY
#define _PACE_USE_PLDUMPFILE_					WHICH_WAY
#define _PACE_USE_FUSELAGE_						WHICH_WAY
#define _PACE_USE_PUBLIC_COM_					WHICH_WAY
#define _PACE_USE_PUBLIC_COMMON_				WHICH_WAY
#define _PACE_USE_PUBLIC_MATH_					WHICH_WAY
#define _PACE_USE_PUBLIC_PROJECT_				WHICH_WAY
#define _PACE_USE_PUBLIC_SERVICE_				WHICH_WAY
#define _PACE_USE_PUBLIC_STORAGE_				WHICH_WAY
#define _PACE_USE_CABINDATA_					WHICH_WAY
#define _PACE_USE_VIEWER_						WHICH_WAY
#define _PACE_USE_DRAFTING_						WHICH_WAY
#define _PACE_USE_OPENDWGFILTER_				WHICH_WAY
#define _PACE_USE_GEOM2D_						WHICH_WAY
#define _PACE_USE_OPENGLVIEWER_					WHICH_WAY
//#define _PACE_USE_PUBLIC_PROJECTA3C_			WHICH_WAY
#define _PACE_USE_OPENINVENTOREXT_				WHICH_WAY
#define _PACE_USE_QUICKTIME_					WHICH_WAY

//#define _PACE_USE_PUBLIC_PROJECTBUGEN_			AS_LIB

#define _PACE_USE_CABINPARAMETER_				AS_LIB

#if WHICH_WAY == AS_LIB
	#define BOOST_RE_STATIC_LIB 1
#endif


#define _PACE_PUBLIC_PROJECT_USE_NEW_USER_ 1
#define _PACE_USE_USER_ 1
#define _PACE_CAB3D_ 1
#define COMMON_CABIN 1
#define _PACE_A3C_

#ifdef _PACE_CAB3D_
	#define _PACE_USE_COIN2_
#endif

#define WINVER 0x500
#pragma warning(disable: 4244)
#pragma warning(disable: 4018)
#pragma warning(disable: 4786)
#pragma warning (disable: 4503)
#pragma warning( disable : 4290 )
#pragma warning( disable : 4114 )

#define PACE_OUTGEN 1
#define _PACE_OUTPUTGENENERATOR_WITH_TCL_ 1
#define _PACE_USE_NO_PROJECTMANAGEMENT_ 1
#define _PACE_USE_USERMANAGEMENT_ 1
#define _PACE_DYN_ATTR_ 1
#define _PACE_USE_USER_ 1
#define _PACE_DEBUG 1
#define _PACE_PLKERN_WITH_HTMLHELP_ 1

#ifdef _DLL		// compile md always as mda (with new streams)
	#define IlrBuildStd 1
	#define _PACE_USE_STD_STREAMS_ 1
	#define IL_STD 1
#else
	#pragma message ("this file uses old pace streams!")
#endif
#define _PACE_ILOG_VIEWS_VER 5
#endif

#if _MSC_VER >= 1300
//#define NOMINMAX   // has to be defined on project level, not in configure.h
#endif

#ifdef _PACE_CABGEN_
#undef _PACE_CABGEN_
#endif
#ifdef _PACE_CABIN_
#undef _PACE_CABIN_
#endif
